/*
************************************************************************
**
** Copyright (c) 2005 The General Electric Company
**
** Author:     Amrish Kapoor
**
** File:      ConfigParameters.h
**
** Objective: Stores Config values read from various config files
**
**
**    Date        Programmer         Description
**    --------------------------------------------------------
**    05/04/2005  Amrish Kapoor      New File(Dynamic config file updation Feature)
*******************************************************************
*/

#ifndef CONFIG_PARAMETERS
#define CONFIG_PARAMETERS

#include "CoilParameters.h"

typedef struct mr_config_params
{
    int ampCalHead;
    int ampCalBody;
    int ampCalMns;
    int maxGradShim;
    int edrThreshold;
    int fieldStrength;
    char broadBandXcvr[5];
    int dfmXshim;
    int dfmYshim;
    int dfmZshim;
    int dfm_shim_scale;
    int dfmZ2shim;
    int isZ2;
    int isZ2autoshim;
    int isZ2tempUpdate;
    int scannerMode;
    int compress;
    int VeryHighFieldScale;
    int fileFormatRev;
    int lineFreq;
    char specRFamp[5];
    char trDither[5];
    int rfBodyVectorZ;
    int rfBodyLength;
    int rfBodyRadius;
    int rfHeadVectorY;
    int rfHeadVectorZ;
    int rfHeadLength;
    int rfHeadRadius;
    int isoVectorZ;
    int tableLimit;
    int begTravel;
    int endTravel;
    int hpdl;
    int bpdl;
    int hpsl;
    int bpsl;
    int hpv;
    int bpv;
    float hqpc;
    float bqpc;
    int hllr;
    int bllr;
    float netLoss;
    int fixedHWtdel;
    int cineTdel;
    int minBW;
}MR_CONFIG_PARAM_TYPE;

typedef struct gradient_config_params
{
     int GCoilType;
     float z2FSAmp;
     float z2full;
     int SRMode;
}GRADIENT_CONFIG_PARAM_TYPE;

typedef struct suite_config_params
{
     char suiteId[7];
     char hospitalName[35];
}SUITE_CONFIG_PARAM_TYPE;

typedef struct host_config_params
{
     char hostName[5];
     char UniqueSystemID[17];
     char ServiceID[17];
     char MobileLocationNumber[5];
}HOST_CONFIG_PARAM_TYPE;

typedef struct pure_config_params
{
     int pure_noise_threshold;
     int pure_intensity_scale;
     int pure_weight_radius;
     int pure_kernelsize_xy;
     int pure_kernelsize_z;
     int pure_fit_order;
     int pure_filter;
}PURE_CONFIG_PARAM_TYPE;

#endif

