#ifndef AUTOSUB_H_INCL
#define AUTOSUB_H_INCL

#define AS_SUCCESS                      (0)
#define AS_FAILURE                     (-1)
#define AS_FAILED_TO_FIND_FIRST_IMAGE  (-2)
#define AS_FAILED_TO_FIND_SECOND_IMAGE (-3)
#define AS_SUB_IMAGE_INSTALL_FAILED    (-4)
#define AS_NOTHING_TO_DO               (-5)

/* Parameters for AutoSubtract (APP) */
typedef struct _AutoSubParam {
    char seriesUidToSubtract[32]; /* DICOM UID of the series to subtract */
    int imageNoToSubtract;        /* Image number of the image to subtract */
    int destSeriesNo;             /* Autosubtract result series number */
    int destImageNo;              /* Autosubtract result image number */
    int dummy;                    /* dummy variable for word alignment (8 byte) */
} AutoSubParam;

int main_process(char* image_uid, char reserved_path[200], int option, AutoSubParam* as_param);
int find_as_series_uid(int exam, int series, char* seriesUID);

#endif

