/*$Id: sw.h,v 1.6 2007/01/23 01:44:55 kunlu Exp $*/
/**<sw.h>**************************************************

   Header file for sw.c

*/
#include <math.h>
#include <stdlib.h>
#include <stdio.h>
#include <stdarg.h>
#include <string.h>
#include <sys/ioctl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/file.h>
#include <sys/fcntl.h>

#if RECON_FLAG==1
    #include "rdbm11x.h" 
#endif
#if RECON_FLAG==2
    #include "rdbm12x.h" 
#endif
#if RECON_FLAG==3
    #include "rdbm14x.h" 
#endif
#if RECON_FLAG==4
    #include "rdbm20x.h" 
#endif
#include "vec.h"

void fftc();

typedef struct SW {		/* spin-warp imaging */

  /* Imaging params */

  int ndx,ndy ;	    /* x and y data dimensions */
  int xoscan,oscan ;/* points and lines before center of K-space */
  int npix ;        /* output pixels, square images for now */
  int reps ;        /* repetitions */
  int ncoil ;       /* # coils */
  int nslice ;      /* # slices */
  int necho ;       /* # echos */
  int nl ;          /* # interleaves */
  int kyorder ;          /* 0=linear 1=centric */
  int etl ;	        /* ymat/nleaf */
  int loopmode ;    /* 1=prep_inside 2=interleaves_inside */
  int nprep ;       /* # prep states */
  int npo2 ;        /* npix/2 */
  int coil_block ;  /* data offset per coil */
  int shift_fov ;   /* switch for off center FOV */
  int phases ;      /* number of phases (ie for cardiac) */
  int segments ;    /* number of TRs to collect ndy lines */
  int nlperseg ;    /* lines per segment */
  int datpertr ;    /* bytes collected per TR */
  
  int xpad1,xpad2 ; /* zero padded points in X direction */
  int ypad1,ypad2 ; /* zero padded points in Y direction */
  
  float xoff, yoff; /* Spatial offsets from isocenter */

  int headfudge ;   /* fudge factor for byte offset into header, default = 0 */
  int headoffset ;  /* byte offset into header, default = HEADERBYTES */

  float ***raw;		/* kspace data */
  short int *ibuf; /* input data buffer */
  
  FILE *fin;

} SW;

